<?php
    // 注意文件字符集统一为 UTF-8
    //echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句

    //ini_set("display_errors", "On");
    date_default_timezone_set("UTC");
    error_reporting(0);

    require_once("contain.php");
    sec_session_start();
    // settings.php require to get some info from session. So put it after sec_session_start()
    require_once("settings.php");
    
    //测试用，有安全隐患
    header("Access-Control-Allow-Origin: *");
    header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept");

    $token = "";
    $respond = (object) array("err"=>ERR_FAILED);
    function throw_error_msg($err, $errmsg = ''){
        global $respond;
        $respond->err = $err;
        if ($errmsg != ''){
            $respond->errmsg = $errmsg;
        }else{
            $errmsg = $err;
        }
        echo json_encode($respond, JSON_UNESCAPED_UNICODE | JSON_PRETTY_PRINT);
        WriteLog('error', $errmsg);
        throw new Exception($errmsg);
    }
    function WriteLog($logLevel,$eventDes){
        $appName = APP_NAME;
        $userName = USER_NAME;
        $ipAddr = USER_IP;
        $log = new \UNAS\Log\UnasLog();
        $log->WriteLog($logLevel,$eventDes,$appName, $userName, $ipAddr);
    }

    if ( $_SERVER["REQUEST_METHOD"] == "POST" ){
        $postdata = file_get_contents("php://input");
        if ( ! empty($postdata) ){
            $request = json_decode($postdata, true);
            if ( isset($request) && (is_array($request)) ){
                require_once("cmds/methods.php");
                $action = $request['action'];
                switch($action) {
                    case 'get_automount_state' :
                        $respond = array_merge(array("err"=>ERR_SUCCEED), get_automount_state());
                    break;
                    case 'set_automount' :
                        $respond = array_merge(array("err"=>ERR_SUCCEED), set_automount($request));
                    break;
                    default:
                        throw_error_msg(ERR_PARAMS, 'Unknown action: '.$action);
                    break;
                }
            }else{
                throw_error_msg(ERR_PARAMS, 'Post data invalid: '.$postdata);
            }
        }else{
            throw_error_msg(ERR_NO_INPUT, 'Post data empty.');
        }
    }else{
        throw_error_msg(ERR_NO_INPUT, 'Unsupported method: '.$_SERVER["REQUEST_METHOD"]);
    }

    echo json_encode($respond, JSON_UNESCAPED_UNICODE);
?>